{{- if .Values.config.postgres.integration }}
{{- $name := (split "." .Values.config.postgres.integration)._1 | default "postgres" }}
{{- $namespace := (split "." (printf "%s." .Values.config.postgres.integration))._0 }}
apiVersion: integration.rock8s.com/v1beta1
kind: Plug
metadata:
  name: postgres
  labels:
    app.kubernetes.io/name: {{ template "sonarqube.name" . }}
    helm.sh/chart: {{ .Chart.Name }}-{{ .Chart.Version }}
    app.kubernetes.io/instance: {{ .Release.Name }}
    app.kubernetes.io/managed-by: {{ .Release.Service }}
spec:
  epoch: {{ now | unixEpoch | quote }}
  socket:
    name: {{ $name }}
    namespace: {{ $namespace }}
  config:
    database: {{ .Values.config.postgres.database | quote }}
    create: '1'
    preserve: '1'
  resources:
    - when: [coupled, updated]
      do: recreate
      stringTemplates:
        - |
          apiVersion: v1
          kind: Secret
          metadata:
            name: postgres
            namespace: {{ .Release.Namespace }}
          data:
            PASSWORD: {% .socketConfig.password | b64enc | quote %}
        - |
          apiVersion: kyverno.io/v1
          kind: Policy
          metadata:
            name: postgres-coupled-or-updated
            namespace: {{ .Release.Namespace }}
          spec:
            background: true
            mutateExistingOnPolicyUpdate: true
            schemaValidation: false
            rules:
              - name: helm-release
                match:
                  resources:
                    kinds:
                      - helm.toolkit.fluxcd.io/*/HelmRelease
                    names:
                      - {{ .Release.Name }}-release
                mutate:
                  targets:
                    - apiVersion: helm.toolkit.fluxcd.io/v2beta1
                      kind: HelmRelease
                      name: {{ .Release.Name }}-release
                  patchesJson6902: |
                    - op: replace
                      path: /spec/values/jdbcOverwrite/jdbcUrl
                      value: 'jdbc:postgresql://{% .socketConfig.hostname %}:{% .socketConfig.port %}/{% .plugConfig.database %}'
                    - op: replace
                      path: /spec/values/jdbcOverwrite/jdbcUsername
                      value: '{% .socketConfig.username %}'
{{- end }}
